/*
 * Copyright (C) 2020 Free Software Foundation, Inc.
 *
 * This file is part of libWARC.
 *
 * libwarc is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libwarc is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with libwarc.  If not, see <https://www.gnu.org/licenses/>.
 */

#include <config.h>

#include <stdio.h>

#include <stdlib.h>
#include <tmpdir.h>
#include <sys/stat.h>
#include <errno.h>
#include <unistd.h>
#include <string.h>

#include "libwarc.h"
#include "private.h"
#include "file.h"

/**
 * \file
 *
 * \brief File handling functions
 */

/**
 * \brief Length for the filename generated by `path_search`.
 */
#define TEMP_FILENAME_LENGTH 20

/**
 * \brief The number of characters required to represent the file number in WARC filename
 */
#define FILE_NUMBER 5

/**
 * \param[in] temp_path The path to the temp directory
 *
 * \return File pointer to the temp file
 *
 * \brief Create a temporary file
 *
 * Temp files are created through the following procedure:
 * 1. Set the temp file path to `/tmp/libwarc/` if given
 * path is NULL.
 * 2. Create the temp directory if it doesn't exist.
 * 3. Construct the template string for the temp file using
 * `path_search` function from the gnulib tmpdir module.
 * 4. Create the temp file using `mkstemp`.
 * 5. Unlink the filename from the file so that the file is
 * solely dependent on the file pointer created in the function.
 */
FILE *create_temp_file(const char *temp_path)
{
    // Set the default path if `temp_path` is NULL
    const char *path;
    if (temp_path == NULL) {
        path = "/tmp/libwarc/";
    } else {
        path = temp_path;
    }

    char temp_filename[strlen(path) + TEMP_FILENAME_LENGTH];

    // Make the directory if it does not exist
    int mkdir_status = mkdir(path, S_IRWXU | S_IXGRP | S_IRWXO);
    if (mkdir_status == -1 && errno != EEXIST) {
        return NULL;
    }

    // Construct the template string for generating name for temp files
    size_t temp_length = strlen(path) + TEMP_FILENAME_LENGTH;
    if (path_search(temp_filename, temp_length, path, "warc", true) == -1) {
        return NULL;
    }

    // Create the temp file
    int fd = mkstemp(temp_filename);
    if (fd < 0) {
        return NULL;
    }

    // Unlink the filename
    if (unlink(temp_filename) < 0) {
        close(fd);
        return NULL;
    }

    return fdopen(fd, "wb+");
}

/**
 * \param[in] session The current WARC session context struct
 *
 * \return 0 On successful completion of the procedure
 *
 * \brief Starts a new WARC file
 *
 * Procedure:
 * 1. Close the current file.
 * 2. Construct the file extension and the filename.
 * 3. Open the file.
 * 4. Write Warcinfo record.
 */
int start_warc_file(warc_session *session)
{
    // Check if base filename is supplied by the user
    if (session->options->warc_filename == NULL) {
        return -1;
    }

    // Close the current file
    if (session->current_file != NULL) {
        fclose(session->current_file);
    }

    const char *extension;

    // Set the extension for the file
#ifdef HAVE_ZLIB
    if (session->options->compression == 0) {
        extension = ".warc.gz";
    } else
        extension = ".warc";
#else
    extension = ".warc";
#endif

    // Construct the full filename for the current file
    size_t base_filename_length = strlen(session->options->warc_filename);
    char filename[base_filename_length + FILE_NUMBER + strlen(extension) + 1];
    sprintf(filename, "%s-%05d%s", session->options->warc_filename, session->number_of_files,
            extension);

    // Open the file
    session->current_file = fopen(filename, "wb+");
    if (session->current_file == NULL) {
        return -1;
    }

    // Increment the number of files
    session->number_of_files++;

    return 0;
}
